HDU3555 Bomb 题解 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3555
题目大意:求 \([1,n]\) 范围内有多少数包含“49”。
解题思路:
这个问题我们可以分两种解法来考虑:第一种是求不包含“49”的数的数量,用后减一下;另一种就是直接求包含“49”的数的数量。

解法1:求多少数不包含“49”

这种方法我们先通过数位DP求出 \([0,n]\) 区间范围内有多少数不包含“49”(假设数量为 \(x\) ),然后可以得到答案为 \(n+1-x\) 。

我们可以设计一个函数 dfs(int pos, int stat, bool limit) 来返回区间 \([0,n]\) 范围内有多少数不包含“49”,其中:

  • pos 表示当前所处数位;
  • stat 表示前一位的数是不是‘4’(如果前一位是‘4’当前位是‘9’则凑成“49”);
  • limit 用于标记当前是否受限制(true:受限制;false:不受限制)。

实现代码如下:

#include <bits/stdc++.h>
using namespace std;
long long f[66][2], n;
int T, a[66];
void init() {
    memset(f, -1, sizeof(f));
}
long long dfs(int pos, int stat, bool limit) {
    if (pos < 0) return 1;
    if (!limit && f[pos][stat] != -1) return f[pos][stat];
    int up = limit ? a[pos] : 9;
    long long tmp = 0;
    for (int i = 0; i <= up; i ++) {
        if (stat && i == 9) continue;
        tmp += dfs(pos-1, i==4, limit && i == up);
    }
    if (!limit) f[pos][stat] = tmp;
    return tmp;
}
long long get_num(long long x) {
    int pos = 0;
    while (x) {
        a[pos++] = x % 10;
        x /= 10;
    }
    return dfs(pos-1, 0, true);
}
int main() {
    init();
    scanf("%d", &T);
    while (T --) {
        scanf("%lld", &n);
        printf("%lld\n", n+1-get_num(n));
    }
    return 0;
}

解法2:求多少数包含“49”

相对解法1是间接的方式进行求解。我们现在这种方式则是 直接 求解 \([0,n]\) 范围内有多少个数包含“49”。

我们可以设计一个函数 dfs(int pos, int stat, bool limit) 来返回区间 \([0,n]\) 范围内有多少数不包含“49”,其中:

  • pos 表示当前所处数位;
  • stat 表示前一位的数是不是‘4’(如果前一位是‘4’当前位是‘9’则凑成“49”);
  • limit 用于标记当前是否受限制(true:受限制;false:不受限制)。

虽然是一样的,但是在处理的时候统计结果的方式却不一样。

这里特别需要注意的是限制条件和非限制条件下不同的处理。

假设我们现在要找的是区间 \([0,n]\) 范围内有多少数包含“49” 遍历到 pos 位并且 pos+1 位是‘4’, pos 位是‘9’,则我们可以得知:

  1. 如果当前处于限制状态下,则之后有 \(n \% 10^{pos} + 1\) 个数满足条件;
  2. 如果当前处于非限制状态下,则之后有 \(10^{pos}\) 个数满足条件。

实现代码如下:

#include <bits/stdc++.h>
using namespace std;
long long f[66][2], n;
int T, a[66];
void init() {
    memset(f, -1, sizeof(f));
}
long long pow10(int a) {
    if (a == 0) return 1;
    if (a == 1) return 10;
    long long t = pow10(a/2);
    return t * t * (a%2 ? 10 : 1);
}
long long dfs(int pos, int stat, bool limit) {
    if (pos < 0) return 0;  // 返回0说明没找到包含49的
    if (!limit && f[pos][stat] != -1) return f[pos][stat];
    int up = limit ? a[pos] : 9;
    long long tmp = 0;
    for (int i = 0; i <= up; i ++) {
        if (stat && i == 9) {   // 说明接下来pos位的10的pos次方个数都满足条件
            // tmp += pow10(pos);   // 直接这么写是错的,此时也要考虑边界条件限制
            // 修正如下
            if (limit) tmp += n % pow10(pos) + 1;
            else tmp += pow10(pos);
        }
        else tmp += dfs(pos-1, i==4, limit && i == up);
    }
    if (!limit) f[pos][stat] = tmp;
    return tmp;
}
long long get_num(long long x) {
    int pos = 0;
    while (x) {
        a[pos++] = x % 10;
        x /= 10;
    }
    return dfs(pos-1, 0, true);
}
int main() {
    init();
    scanf("%d", &T);
    while (T --) {
        scanf("%lld", &n);
        printf("%lld\n", get_num(n));
    }
    return 0;
}

原文地址:https://www.cnblogs.com/quanjun/p/11964644.html

时间: 2024-10-02 19:11:59

HDU3555 Bomb 题解 数位DP的相关文章

HDU3555 Bomb(数位dp)

Problem Description The counter-terrorists found a time bomb in the dust. But this time the terrorists improve on the time bomb. The number sequence of the time bomb counts from 1 to N. If the current number sequence includes the sub-sequence "49&quo

hdu 3555 Bomb(数位dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3555 题目大意:就是给你一个数n,判断从0到n有多少个数含有数字49...... 是不是觉得跟hdu2089很相似呀... 思路:跟hdu2089一样的,注意给出的数比较大,所以这儿用__int64  .... code: #include<cstdio> #include<iostream> #include<cstring> #include<algorithm&

HDU - 3555 Bomb (数位DP)

题意:求1-n里有多少人包含"49"的数字 思路:数位DP,分三种情况:到第i位没有49的情况,到第i位没有49且最高位是9的情况,到第i位有49的情况,将三种情况都考虑进去就是了 #include <iostream> #include <cstdio> #include <cstring> #include <algorithm> using namespace std; long long dp[30][3], n; int arr

HDU 3555 Bomb(数位DP啊)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3555 Problem Description The counter-terrorists found a time bomb in the dust. But this time the terrorists improve on the time bomb. The number sequence of the time bomb counts from 1 to N. If the curre

HDU2089 不要62 题解 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2089 题目大意:求区间 \([l,r]\) 范围内不包含数字"4"且不包含连续的数字"62"的数的数量. 解题思路: 数位DP 入门题. 我们开一个函数 dfs(int pos, int stat, bool limit) ,其中: pos表示目前将要访问的数的位置: pre表示前一个值是不是6,因为这里涉及到62连数(而单个4不需要存储之前的状态, stat \(=1

HDU4734 F(x) 题解 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4734 题目大意: 对于一个 \(n\) 位十进制数 \(x\) (\(A_nA_{n-1}A_{n-2} \cdots A_2A_1\)),我们定义 \[F(x)=A_n \times 2^{n-1} + A_{n-1} \times 2^{n-2} + \cdots + A_2 \times 2 + A_1 \times 1\] 现在给你两个数 \(A\) 和 \(B\) ,请计算出区间 \([0

POJ3252 Round Numbers 题解 数位DP

题目大意: 求区间 \([x,y]\) 范围内有多少数的二进制表示中的'0'的个数 \(\ge\) '1'的个数. 解题思路: 使用 数位DP 解决这个问题. 我们设状态 f[pos][num0][num1][all0] 表示在: 当前所在数位为 pos : 当前选择的'0'的个数为 num0: 当前选择的'1'的个数为 num1: 到当前位位置是不是前面的数都是前导零(如果都是前导0则 all0==true,否则 all==false). 下的方案数. 我们开函数 dfs(int pos, i

HDU5179 beautiful number 题解 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5179 题目大意: 给你一个数 \(A = a_1a_2 \cdots a_n\) ,我们称 \(A\) 为"漂亮的数"当且仅当 \(a[i] \ge a[i+1]\) (\(1 \le i \lt n\)) 并且 \(a[i]\) mod \(a[j] = 0\) (\(1 \le i \lt n, i \lt j \le n\)),比如 \(931\) 就是一个漂亮的数. 求区间 \([

HDU4507 吉哥系列故事——恨7不成妻 题解 数位DP

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4507 题目大意: 找到区间 \([L,R]\) 范围内所有满足如下条件的数的 平方和 : 不包含'7': 不能被 7 整除: 各位之和不能被 7 整除. 注意:求的是满足条件的数的 平方和 ! 解题思路: 使用 数位DP 尽情求解. 但是因为这里求的是满足要求的元素的平方和,而不是元素的个数. 所以我们不能简单地开long long来存放结果, 而是开一个结构体来存放结果,结构体中需要包含三个元素: